/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-debugger.c -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "ianjuta-debugger.h"
#include "libanjuta-iface-marshallers.h"

GQuark 
ianjuta_debugger_error_quark (void)
{
	static GQuark quark = 0;
	
	if (quark == 0) {
		quark = g_quark_from_static_string ("ianjuta-debugger-quark");
	}
	
	return quark;
}

/**
* ianjuta_debugger_abort:
* @obj: Self
* @err: Error propagation and reporting.
* 
* Quit the debugger as fast as possible.
*
* Returns: TRUE if sucessful, other FALSE.
*/
gboolean
ianjuta_debugger_abort (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->abort (obj, err);
}

/**
* ianjuta_debugger_attach:
* @obj: Self
* @pid: fixme
* @source_search_directories: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: TRUE if sucessful, other FALSE.
*/
gboolean
ianjuta_debugger_attach (IAnjutaDebugger *obj, pid_t pid,  const GList* source_search_directories, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->attach (obj, pid, source_search_directories, err);
}

/**
* ianjuta_debugger_callback:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_callback (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->callback (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_clear_breakpoint:
* @obj: Self
* @id: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_clear_breakpoint (IAnjutaDebugger *obj, guint id,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->clear_breakpoint (obj, id, callback, user_data, err);
}

/**
* ianjuta_debugger_condition_breakpoint:
* @obj: Self
* @id: fixme
* @condition: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_condition_breakpoint (IAnjutaDebugger *obj, guint id,   const gchar* condition,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (condition != NULL, FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->condition_breakpoint (obj, id, condition, callback, user_data, err);
}

/**
* ianjuta_debugger_disable_log:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
void
ianjuta_debugger_disable_log (IAnjutaDebugger *obj, GError **err)
{
	g_return_if_fail (IANJUTA_IS_DEBUGGER(obj));
	IANJUTA_DEBUGGER_GET_IFACE (obj)->disable_log (obj, err);
}

/**
* ianjuta_debugger_enable_breakpoint:
* @obj: Self
* @id: fixme
* @enable: fixme
* @callback: fixme
* @user_data: fixme	
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_enable_breakpoint (IAnjutaDebugger *obj, guint id,   gboolean enable,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->enable_breakpoint (obj, id, enable, callback, user_data, err);
}

/**
* ianjuta_debugger_enable_log:
* @obj: Self
* @log: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
void
ianjuta_debugger_enable_log (IAnjutaDebugger *obj, IAnjutaMessageView *log, GError **err)
{
	g_return_if_fail (IANJUTA_IS_DEBUGGER(obj));
	g_return_if_fail (IANJUTA_IS_MESSAGE_VIEW(log));
	IANJUTA_DEBUGGER_GET_IFACE (obj)->enable_log (obj, log, err);
}

/**
* ianjuta_debugger_evaluate:
* @obj: Self
* @name: fixme
* @value: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_evaluate (IAnjutaDebugger *obj, const gchar* name,   const gchar* value,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	g_return_val_if_fail (value != NULL, FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->evaluate (obj, name, value, callback, user_data, err);
}

/**
* ianjuta_debugger_exit:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_exit (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->exit (obj, err);
}

/**
* ianjuta_debugger_get_status:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
IAnjutaDebuggerStatus
ianjuta_debugger_get_status (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), 0);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->get_status (obj, err);
}

/**
* ianjuta_debugger_handle_signal:
* @obj: Self
* @name: fixme
* @stop: fixme
* @print: fixme
* @ignore: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_handle_signal (IAnjutaDebugger *obj, const gchar *name,   gboolean stop,   gboolean print,   gboolean ignore, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->handle_signal (obj, name, stop, print, ignore, err);
}

/**
* ianjuta_debugger_ignore_breakpoint:
* @obj: Self
* @id: fixme
* @ignore: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_ignore_breakpoint (IAnjutaDebugger *obj, guint id,   guint ignore,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->ignore_breakpoint (obj, id, ignore, callback, user_data, err);
}

/**
* ianjuta_debugger_info_args:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_args (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_args (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_frame:
* @obj: Self
* @frame: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_frame (IAnjutaDebugger *obj, guint frame,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_frame (obj, frame, callback, user_data, err);
}

/**
* ianjuta_debugger_info_program:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_program (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_program (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_sharedlib:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_sharedlib (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_sharedlib (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_signal:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_signal (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_signal (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_target:
* @obj: Self
* @funx: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_target (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_target (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_threads:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_threads (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_threads (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_udot:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_udot (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_udot (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_info_variables:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_info_variables (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->info_variables (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_initialize:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: TRUE if sucessful, other FALSE.
*/
gboolean
ianjuta_debugger_initialize (IAnjutaDebugger *obj, IAnjutaDebuggerOutputCallback func,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->initialize (obj, func, user_data, err);
}

/**
* ianjuta_debugger_inspect:
* @obj: Self
* @name: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_inspect (IAnjutaDebugger *obj, const gchar* name,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->inspect (obj, name, callback, user_data, err);
}

/**
* ianjuta_debugger_interrupt:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_interrupt (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->interrupt (obj, err);
}

/**
* ianjuta_debugger_list_argument:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_list_argument (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->list_argument (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_list_frame:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_list_frame (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->list_frame (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_list_local:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_list_local (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->list_local (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_list_register:
* @obj: Self
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_list_register (IAnjutaDebugger *obj, IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->list_register (obj, callback, user_data, err);
}

/**
* ianjuta_debugger_load:
* @obj: Self
* @file: fixme
* @mime_type: fixme
* @source_search_directories: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: TRUE if sucessful, other FALSE.
*/
gboolean
ianjuta_debugger_load (IAnjutaDebugger *obj, const gchar *file,   const gchar *mime_type,  const GList* source_search_directories, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	g_return_val_if_fail (mime_type != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->load (obj, file, mime_type, source_search_directories, err);
}

/**
* ianjuta_debugger_print:
* @obj: Self
* @variable: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_print (IAnjutaDebugger *obj, const gchar *variable,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (variable != NULL, FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->print (obj, variable, callback, user_data, err);
}

/**
* ianjuta_debugger_quit:
* @obj: Self
* @err: Error propagation and reporting.
* 
* Quit the debugger, can wait until the debugger is ready.
*
* Returns: TRUE if sucessful, other FALSE.
*/
gboolean
ianjuta_debugger_quit (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->quit (obj, err);
}

/**
* ianjuta_debugger_run:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_run (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->run (obj, err);
}

/**
* ianjuta_debugger_run_to:
* @obj: Self
* @uri: fixme
* @line: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_run_to (IAnjutaDebugger *obj, const gchar *uri,   gint line, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (uri != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->run_to (obj, uri, line, err);
}

/**
* ianjuta_debugger_send_command:
* @obj: Self
* @command: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_send_command (IAnjutaDebugger *obj, const gchar *command, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (command != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->send_command (obj, command, err);
}

/**
* ianjuta_debugger_set_breakpoint_at_address:
* @obj: Self
* @address: fixme
* @callback: fixme
* @user_date: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_set_breakpoint_at_address (IAnjutaDebugger *obj, guint address,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->set_breakpoint_at_address (obj, address, callback, user_data, err);
}

/**
* ianjuta_debugger_set_breakpoint_at_function:
* @obj: Self
* @file: fixme
* @function: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_set_breakpoint_at_function (IAnjutaDebugger *obj, const gchar* file,   const gchar* function,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	g_return_val_if_fail (function != NULL, FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->set_breakpoint_at_function (obj, file, function, callback, user_data, err);
}

/**
* ianjuta_debugger_set_breakpoint_at_line:
* @obj: Self
* @file: fixme
* @line: fixme
* @callback: fixme
* @user_data: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_set_breakpoint_at_line (IAnjutaDebugger *obj, const gchar* file,   guint line,   IAnjutaDebuggerCallback callback,   gpointer user_data, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	g_return_val_if_fail (user_data != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->set_breakpoint_at_line (obj, file, line, callback, user_data, err);
}

/**
* ianjuta_debugger_set_frame:
* @obj: Self
* @frame: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_set_frame (IAnjutaDebugger *obj, guint frame, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->set_frame (obj, frame, err);
}

/**
* ianjuta_debugger_start:
* @obj: Self
* @args: fixme
* @terminal: fixme
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: TRUE if sucessful, other FALSE.
*/
gboolean
ianjuta_debugger_start (IAnjutaDebugger *obj, const gchar *args,   gboolean terminal, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	g_return_val_if_fail (args != NULL, FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->start (obj, args, terminal, err);
}

/**
* ianjuta_debugger_step_in:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_step_in (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->step_in (obj, err);
}

/**
* ianjuta_debugger_step_out:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_step_out (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->step_out (obj, err);
}

/**
* ianjuta_debugger_step_over:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_step_over (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->step_over (obj, err);
}

/**
* ianjuta_debugger_unload:
* @obj: Self
* @err: Error propagation and reporting.
* 
* fixme
*
* Returns: fixme
*/
gboolean
ianjuta_debugger_unload (IAnjutaDebugger *obj, GError **err)
{
	g_return_val_if_fail (IANJUTA_IS_DEBUGGER(obj), FALSE);
	return IANJUTA_DEBUGGER_GET_IFACE (obj)->unload (obj, err);
}

static void
ianjuta_debugger_base_init (gpointer gclass)
{
	static gboolean initialized = FALSE;
	
	if (!initialized) {
		/* Signal */
		g_signal_new ("debugger-ready",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, debugger_ready),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__ENUM,
			G_TYPE_NONE,
			1,
			IANJUTA_TYPE_DEBUGGER_STATUS);

		/* Signal */
		g_signal_new ("debugger-started",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, debugger_started),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("debugger-stopped",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, debugger_stopped),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("frame-changed",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, frame_changed),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__UINT,
			G_TYPE_NONE,
			1,
			G_TYPE_UINT);

		/* Signal */
		g_signal_new ("location-changed",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, location_changed),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__STRING_UINT_STRING,
			G_TYPE_NONE,
			3,
			G_TYPE_STRING,
			G_TYPE_UINT,
			G_TYPE_STRING);

		/* Signal */
		g_signal_new ("program-exited",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, program_exited),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("program-loaded",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, program_loaded),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("program-running",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, program_running),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("program-stopped",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, program_stopped),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("send",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, send),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("sharedlib-event",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, sharedlib_event),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__VOID,
			G_TYPE_NONE,
			0,
			NULL);

		/* Signal */
		g_signal_new ("status-changed",
			IANJUTA_TYPE_DEBUGGER,
			G_SIGNAL_RUN_LAST,
			G_STRUCT_OFFSET (IAnjutaDebuggerIface, status_changed),
			NULL, NULL,
			libanjuta_iface_cclosure_marshal_VOID__ENUM,
			G_TYPE_NONE,
			1,
			IANJUTA_TYPE_DEBUGGER_STATUS);


		initialized = TRUE;
	}
}

GType
ianjuta_debugger_get_type (void)
{
	static GType type = 0;
	if (!type) {
		static const GTypeInfo info = {
			sizeof (IAnjutaDebuggerIface),
			ianjuta_debugger_base_init,
			NULL, 
			NULL,
			NULL,
			NULL,
			0,
			0,
			NULL
		};
		type = g_type_register_static (G_TYPE_INTERFACE, "IAnjutaDebugger", &info, 0);
		g_type_interface_add_prerequisite (type, G_TYPE_OBJECT);
	}
	return type;			
}

GType
ianjuta_debugger_breakpoint_type_get_type (void)
{
	static const GEnumValue values[] =
	{
		{ IANJUTA_DEBUGGER_BREAK_ON_LINE, "IANJUTA_DEBUGGER_BREAK_ON_LINE", "break-on-line" }, 
		{ IANJUTA_DEBUGGER_BREAK_ON_ADDRESS, "IANJUTA_DEBUGGER_BREAK_ON_ADDRESS", "break-on-address" }, 
		{ IANJUTA_DEBUGGER_BREAK_ON_FUNCTION, "IANJUTA_DEBUGGER_BREAK_ON_FUNCTION", "break-on-function" }, 
		{ 0, NULL, NULL }
	};

	static GType type = 0;

	if (! type)
	{
		type = g_enum_register_static ("IAnjutaDebuggerBreakpointType", values);
	}

	return type;
}

GType
ianjuta_debugger_data_get_type (void)
{
	static const GEnumValue values[] =
	{
		{ IANJUTA_DEBUGGER_INFORMATION, "IANJUTA_DEBUGGER_INFORMATION", "information" }, 
		{ IANJUTA_DEBUGGER_BREAKPOINT, "IANJUTA_DEBUGGER_BREAKPOINT", "breakpoint" }, 
		{ IANJUTA_DEBUGGER_FRAME, "IANJUTA_DEBUGGER_FRAME", "frame" }, 
		{ IANJUTA_DEBUGGER_VARIABLE, "IANJUTA_DEBUGGER_VARIABLE", "variable" }, 
		{ IANJUTA_DEBUGGER_REGISTER, "IANJUTA_DEBUGGER_REGISTER", "register" }, 
		{ 0, NULL, NULL }
	};

	static GType type = 0;

	if (! type)
	{
		type = g_enum_register_static ("IAnjutaDebuggerData", values);
	}

	return type;
}

GType
ianjuta_debugger_error_get_type (void)
{
	static const GEnumValue values[] =
	{
		{ IANJUTA_DEBUGGER_OK, "IANJUTA_DEBUGGER_OK", "ok" }, 
		{ IANJUTA_DEBUGGER_NOT_READY, "IANJUTA_DEBUGGER_NOT_READY", "not-ready" }, 
		{ IANJUTA_DEBUGGER_NOT_RUNNING, "IANJUTA_DEBUGGER_NOT_RUNNING", "not-running" }, 
		{ IANJUTA_DEBUGGER_NOT_STOPPED, "IANJUTA_DEBUGGER_NOT_STOPPED", "not-stopped" }, 
		{ IANJUTA_DEBUGGER_NOT_LOADED, "IANJUTA_DEBUGGER_NOT_LOADED", "not-loaded" }, 
		{ IANJUTA_DEBUGGER_NOT_STARTED, "IANJUTA_DEBUGGER_NOT_STARTED", "not-started" }, 
		{ IANJUTA_DEBUGGER_NOT_CONNECTED, "IANJUTA_DEBUGGER_NOT_CONNECTED", "not-connected" }, 
		{ IANJUTA_DEBUGGER_NOT_IMPLEMENTED, "IANJUTA_DEBUGGER_NOT_IMPLEMENTED", "not-implemented" }, 
		{ IANJUTA_DEBUGGER_CANCEL, "IANJUTA_DEBUGGER_CANCEL", "cancel" }, 
		{ IANJUTA_DEBUGGER_UNABLE_TO_CREATE_VARIABLE, "IANJUTA_DEBUGGER_UNABLE_TO_CREATE_VARIABLE", "unable-to-create-variable" }, 
		{ IANJUTA_DEBUGGER_UNABLE_TO_ACCESS_MEMORY, "IANJUTA_DEBUGGER_UNABLE_TO_ACCESS_MEMORY", "unable-to-access-memory" }, 
		{ IANJUTA_DEBUGGER_UNKNOWN_ERROR, "IANJUTA_DEBUGGER_UNKNOWN_ERROR", "unknown-error" }, 
		{ 0, NULL, NULL }
	};

	static GType type = 0;

	if (! type)
	{
		type = g_enum_register_static ("IAnjutaDebuggerError", values);
	}

	return type;
}

GType
ianjuta_debugger_output_type_get_type (void)
{
	static const GEnumValue values[] =
	{
		{ IANJUTA_DEBUGGER_OUTPUT, "IANJUTA_DEBUGGER_OUTPUT", "output" }, 
		{ IANJUTA_DEBUGGER_WARNING_OUTPUT, "IANJUTA_DEBUGGER_WARNING_OUTPUT", "warning-output" }, 
		{ IANJUTA_DEBUGGER_ERROR_OUTPUT, "IANJUTA_DEBUGGER_ERROR_OUTPUT", "error-output" }, 
		{ IANJUTA_DEBUGGER_INFO_OUTPUT, "IANJUTA_DEBUGGER_INFO_OUTPUT", "info-output" }, 
		{ 0, NULL, NULL }
	};

	static GType type = 0;

	if (! type)
	{
		type = g_enum_register_static ("IAnjutaDebuggerOutputType", values);
	}

	return type;
}

GType
ianjuta_debugger_state_get_type (void)
{
	static const GEnumValue values[] =
	{
		{ IANJUTA_DEBUGGER_UNDEFINED, "IANJUTA_DEBUGGER_UNDEFINED", "undefined" }, 
		{ IANJUTA_DEBUGGER_NO, "IANJUTA_DEBUGGER_NO", "no" }, 
		{ IANJUTA_DEBUGGER_YES, "IANJUTA_DEBUGGER_YES", "yes" }, 
		{ 0, NULL, NULL }
	};

	static GType type = 0;

	if (! type)
	{
		type = g_enum_register_static ("IAnjutaDebuggerState", values);
	}

	return type;
}

GType
ianjuta_debugger_status_get_type (void)
{
	static const GEnumValue values[] =
	{
		{ IANJUTA_DEBUGGER_BUSY, "IANJUTA_DEBUGGER_BUSY", "busy" }, 
		{ IANJUTA_DEBUGGER_STOPPED, "IANJUTA_DEBUGGER_STOPPED", "stopped" }, 
		{ IANJUTA_DEBUGGER_STARTED, "IANJUTA_DEBUGGER_STARTED", "started" }, 
		{ IANJUTA_DEBUGGER_PROGRAM_LOADED, "IANJUTA_DEBUGGER_PROGRAM_LOADED", "program-loaded" }, 
		{ IANJUTA_DEBUGGER_PROGRAM_RUNNING, "IANJUTA_DEBUGGER_PROGRAM_RUNNING", "program-running" }, 
		{ IANJUTA_DEBUGGER_PROGRAM_STOPPED, "IANJUTA_DEBUGGER_PROGRAM_STOPPED", "program-stopped" }, 
		{ 0, NULL, NULL }
	};

	static GType type = 0;

	if (! type)
	{
		type = g_enum_register_static ("IAnjutaDebuggerStatus", values);
	}

	return type;
}
